/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/CustDetailsRequest.java-arc   1.3   Mar 21 2005 08:43:16   adij  $
 * $Revision:   1.3  $
 * $Date:   Mar 21 2005 08:43:16  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 */
package com.capgemini.nemmco.b2bb;

import com.capgemini.nemmco.b2bb.enums.TransactionType;

/**
 * The class <code>CustomerDetailsRequest</code> represents a CustomerDetailsRequest
 * Transaction.
 *
 * @author  $Author:   adij  $
 * @version $Revision:   1.3  $
 */
public class CustDetailsRequest extends Transaction {

  public static final String NMI_FIELD = "NMI";
  public static final String NMI_CHECKSUM = "NMIChecksum";
  public static final String REASON = "reason";
  public static final String COMMENT_LINE1 = "commentLine1";
  public static final String COMMENT_LINE2 = "commentLine2";
  public static final String COMMENT_LINE3 = "commentLine3";

  private String NMI = "";
  private String NMIChecksum = "";
  private String reason = "";
  private String commentLine1 = "";
  private String commentLine2 = "";
  private String commentLine3 = "";

  /**
   * Default Constructor
   */
  public CustDetailsRequest() {
    super(TransactionType.CUST_DETAIL_REQUEST);
  }

  /**
   * @return Returns the nMI.
   */
  public String getNMI() {
    return NMI;
  }

  /**
   * @return Returns the nMIChecksum.
   */
  public String getNMIChecksum() {
    return NMIChecksum;
  }

  /**
   * @return Returns the reason.
   */
  public String getReason() {
    return reason;
  }

  /**
   * @return Returns the commentLine1.
   */
  public String getCommentLine1() {
    return commentLine1;
  }

  /**
   * @return Returns the commentLine2.
   */
  public String getCommentLine2() {
    return commentLine2;
  }

  /**
   * @return Returns the commentLine3.
   */
  public String getCommentLine3() {
    return commentLine3;
  }

  /**
   * @param nmi The nMI to set.
   */
  public void setNMI(String nmi) {
    NMI = nmi;
  }

  /**
   * @param checksum The nMIChecksum to set.
   */
  public void setNMIChecksum(String checksum) {
    NMIChecksum = checksum;
  }

  /**
   * @param reason The reason to set.
   */
  public void setReason(String reason) {
    this.reason = reason;
  }

  /**
   * @param commentLine1 The commentLine1 to set.
   */
  public void setCommentLine1(String commentLine1) {
    this.commentLine1 = commentLine1;
  }

  /**
   * @param commentLine2 The commentLine2 to set.
   */
  public void setCommentLine2(String commentLine2) {
    this.commentLine2 = commentLine2;
  }

  /**
   * @param commentLine3 The commentLine3 to set.
   */
  public void setCommentLine3(String commentLine3) {
    this.commentLine3 = commentLine3;
  }

}

