/**
 * NotifiedParty.java
 * <p>
 * The Copyright of this work is vested in the National Electricity Market
 * Management Company Limited and the software is issued in confidence
 * for the purpose only for which it is supplied. It must not be
 * reproduced in whole or in part or used for tendering or manufacturing
 * purposes except under an agreement or with the consent in writing of
 * the National Electricity Market Management Company Limited and then
 * only on the condition that this notice is included in any such
 * reproduction.  No information as to the contents or subject matter of
 * this software or any part thereof arising directly or indirectly there
 * from shall be given orally or in writing or communicated in any manner
 * whatsoever to any third party being an individual firm or company or
 * any employee thereof without the prior consent in writing of the
 * National Electricity Market Management Company Limited.
 * <p>
 * Copyright National Electricity Market Management Company Limited. 2009
 * <p>
 * Modification History
 * <p>
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 21-Jan-2009    Eddie Graham      Created.
 * 18-Mar-2011    Eddie Graham      Defect 7087. Add new method getOneWayNotificationNames()
 * to return list of One Way Notification Names.
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb;

import com.capgemini.nemmco.b2bb.enums.TransactionType;

public class PTPDataExchange extends Transaction {


    public static final String FREE_FORM_DATA = "freeFormData";
    public static final String FORMAT = "format";
    public static final String CONTECT_ID = "contextID";
    public static final String OTHER = "other";

    private String freeFormData = " ";
    private String format = "";
    private String contextID = "";
    private String other = "";

    /**
     * Default Constructor
     */
    public PTPDataExchange() {
        super(TransactionType.PEER_TO_PEER);
    }

    /**
     * @return Returns the freeFormData.
     */
    public String getFreeFormData() {
        return freeFormData;
    }

    /**
     * @param freeFormData The freeFormData to set.
     */
    public void setFreeFormData(String freeFormData) {
        this.freeFormData = freeFormData;

    }

    /**
     * @return Returns the attachmentType1.
     */
    public String getFormat() {
        return format;
    }

    /**
     * @param attachmentType1 The attachmentType1 to set.
     */
    public void setFormat(String format) {
        this.format = format;
    }

    /**
     * @return Returns the attachmentType2.
     */
    public String getContextID() {
        return contextID;
    }

    /**
     * @param attachmentType2 The attachmentType2 to set.
     */
    public void setContextID(String contextID) {
        this.contextID = contextID;
    }

    /**
     * @return Returns the attachmentType3.
     */
    public String getOther() {
        return other;
    }

    public void setOther(String other) {
        this.other = other;
    }






    /**
     * @param attachmentType3 The attachmentType3 to set.
     */

}

