/*
* SiteAccessRequest.java
*
* The Copyright of this work is vested in the Australian Energy Market
* Operator (AEMO) and the software is issued in confidence for the purpose
* only for which it is supplied. It must not be reproduced in whole or in
* part or used for tendering or manufacturing purposes except under an
* agreement or with the consent in writing of AEMO and then only on the
* condition that this notice is included in any such reproduction.
* No information as to the contents or subject matter of this software or
* any part thereof arising directly or indirectly there from shall be
* given orally or in writing or communicated in any manner whatsoever to
* any third party being an individual firm or company or any employee
* thereof without the prior consent in writing of AEMO.
*
* Copyright Australian Energy Market Operator Limited. 2017
*
* Modification History
*
* Date Changed   Changed By        Description
* ------------   ----------        -----------
* 25-Jun-2017    Harpreet Kaur     Created
* 24-Jul-2017    Harpreet Kaur     Changes to fix defect 7473, 7478, 7479
*/


package com.capgemini.nemmco.b2bb;

import com.capgemini.nemmco.b2bb.enums.SiteAccessRequestReasons;
import com.capgemini.nemmco.b2bb.enums.TransactionType;

import java.util.List;

public class SiteAccessRequest extends Transaction {

   public static final String REASON = "reason";
   public static final String SPECIAL_NOTES1 = "specialNotes1";
   public static final String SPECIAL_NOTES2 = "specialNotes2";
   public static final String SPECIAL_NOTES3 = "specialNotes3";

   private String reason = "";
   private String specialNotes1 = "";
   private String specialNotes2 = "";
   private String specialNotes3 = "";

   /**
    * Default Constructor
    */
   public SiteAccessRequest() {
      super(TransactionType.SITE_ACCESS_REQ);
   }

    /**
    * @param reason The reason to set.
    */
   public void setReason(String reason) {
      this.reason = reason;
   }
   /**
    * @return Returns the reason.
    */
   public String getReason() {
      return reason;
   }

   /**
    * Getter for siteAccessRequestReasons
    * @return List
    */
   public List<? extends Object> getSiteAccessRequestReasons() {
      return SiteAccessRequestReasons.SITE_ACCESS_REQUEST_REASONS;
   }

   /**
    * @param specialNotes1 The specialNotes1 to set.
    */
   public void setSpecialNotes1(String specialNotes1) {
      this.specialNotes1 = specialNotes1;
   }
   /**
    * @return Returns the specialNotes1.
    */
   public String getSpecialNotes1() {
      return specialNotes1;
   }
   /**
    * @param specialNotes2 The specialNotes2 to set.
    */
   public void setSpecialNotes2(String specialNotes2) {
      this.specialNotes2 = specialNotes2;
   }
   /**
    * @return Returns the specialNotes2.
    */
   public String getSpecialNotes2() {
      return specialNotes2;
   }
   /**
    * @param specialNotes3 The specialNotes3 to set.
    */
   public void setSpecialNotes3(String specialNotes3) {
      this.specialNotes3 = specialNotes3;
   }
   /**
    * @return Returns the specialNotes3.
    */
   public String getSpecialNotes3() {
      return specialNotes3;
   }

}
