/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/FileType.java-arc   1.2   11 Apr 2005 11:10:44   RayanS  $
 * $Revision:   1.2  $
 * $Date:   11 Apr 2005 11:10:44  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        ----------- 
 * 10-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7. 
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the priority Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.2  $ $Date:   11 Apr 2005 11:10:44  $
 */
public class FileType extends Enumeration implements Comparable<Object>, java.io.Serializable {

  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;

  public static final FileType ZIP = new FileType(".zip", ".zip");
  public static final FileType ACK = new FileType(".ack", ".ack");
  public static final FileType AC1 = new FileType(".ac1", ".ac1");
  public static final FileType TMP = new FileType(".tmp", ".tmp");
  public static final FileType XML = new FileType(".xml", ".xml");
  
  private static final FileType[] FILE_TYPE_ARRAY = {
      ZIP, ACK, AC1};

  public static final List<? extends Object> FILE_TYPES = Collections.unmodifiableList(Arrays.asList(FILE_TYPE_ARRAY));

  /**
   * Return the FileType object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static FileType getFileType(String code) {
    for (int i = 0; i < FILE_TYPES.size(); i++) {
      if ((((Enumeration) FILE_TYPES.get(i)).getCode()).equals(code))
          return (FileType) FILE_TYPES.get(i);
    }
    return null;
  }

  private FileType(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

