/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/InvestigationCode.java-arc   1.3   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:40  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 * 27-Jun-2017    Harpreet Kaur  7135 Package7B Added and removed new dropdown options for InvestigationCode in VerifyMeterDataRequest
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class InvestigationCode extends Enumeration
                               implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

    /**
		  * The following define the enumerations.
		  */
    public static final InvestigationCode CONFIRM_READ_FROM_VACANT_SITE = new InvestigationCode("Confirm Reading For Vacant Site", "Confirm Reading For Vacant Site");
    public static final InvestigationCode CONFIRM_ZERO_CONSUMPTION      = new InvestigationCode("Confirm Zero Consumption", "Confirm Zero Consumption");
    public static final InvestigationCode INCOMPLETE_DATA               = new InvestigationCode("Incomplete Data", "Incomplete Data");
    public static final InvestigationCode INVALID_MDFF_DATA             = new InvestigationCode("Invalid MDFF Data", "Invalid MDFF Data");
    public static final InvestigationCode INVALID_STANDING_DATA         = new InvestigationCode("Invalid Standing Data", "Invalid Standing Data");
    public static final InvestigationCode METER_CHURN                   = new InvestigationCode("Meter Churn", "Meter Churn");
    public static final InvestigationCode MISSING_DATASTREAM            = new InvestigationCode("Missing Datastream", "Missing Datastream");
    public static final InvestigationCode REQUIRE_ACTUAL_OR_SUBSTITUTE  = new InvestigationCode("Require Actual Reading or Substitute", "Require Actual Reading or Substitute");
    public static final InvestigationCode REQUIRE_ESTIMATE_DATA         = new InvestigationCode("Require Estimate Data", "Require Estimate Data");
    public static final InvestigationCode REQUIRE_FINAL_SUBSTITUTE      = new InvestigationCode("Require Final Substitute", "Require Final Substitute");
    public static final InvestigationCode SCHEDULED_READING_REQUIRED    = new InvestigationCode("Scheduled Reading Required", "Scheduled Reading Required");
    public static final InvestigationCode SOR_READING_REQUIRED          = new InvestigationCode("Service Order Reading Required", "Service Order Reading Required");
    public static final InvestigationCode VERIFY_HIGH_READING           = new InvestigationCode("Verify High Reading", "Verify High Reading");
    public static final InvestigationCode VERIFY_LOW_READING            = new InvestigationCode("Verify Low Reading", "Verify Low Reading");
    public static final InvestigationCode VERIFY_OR_MISSING_REGISTER    = new InvestigationCode("Verify/Missing Register", "Verify/Missing Register");
    public static final InvestigationCode OTHER                         = new InvestigationCode("Other", "Other");

    private static final InvestigationCode[] INVESTIGATION_CODE_ARRAY =
      { CONFIRM_READ_FROM_VACANT_SITE,
        CONFIRM_ZERO_CONSUMPTION,
        INCOMPLETE_DATA,
        INVALID_MDFF_DATA,
        INVALID_STANDING_DATA,
        METER_CHURN,
        MISSING_DATASTREAM,
        REQUIRE_ACTUAL_OR_SUBSTITUTE,
        REQUIRE_ESTIMATE_DATA,
        REQUIRE_FINAL_SUBSTITUTE,
        SCHEDULED_READING_REQUIRED,
        SOR_READING_REQUIRED,
        VERIFY_HIGH_READING,
        VERIFY_LOW_READING,
        VERIFY_OR_MISSING_REGISTER,
        OTHER
      };

    public static final List<? extends Object> INVESTIGATION_CODES =
      Collections.unmodifiableList(Arrays.asList(INVESTIGATION_CODE_ARRAY));

    private InvestigationCode(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

