/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/MeteringType.java-arc   1.3   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 * 21-Aug-2017    Harpreet Kaur     7135 Package 7B: Changes done for new values of MeteringRequired as part of POC SMP
 * 25-Aug-2017    Harpreet Kaur     7135 Package 7B: Defect#7693 fix
 * 17-Oct-2017    Hamish McNeish    8176 Allow Other as a MeteringType option 
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class MeteringType extends Enumeration 
                                      implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */

    public static final MeteringType HV_METERING_EXPORT_ONLY  = new MeteringType("HV Metering Export only", "HV Metering Export only");
    public static final MeteringType LV_CT_METERING_EXPORT_ONLY    = new MeteringType("LV CT Metering Export only", "LV CT Metering Export only");
    public static final MeteringType THREE_PHASE_EXPORT_ONLY = new MeteringType("Three Phase Whole Current Export only", "Three Phase Whole Current Export only");
    public static final MeteringType SINGLE_PHASE_EXPORT_ONLY    = new MeteringType("Single Phase Export only", "Single Phase Export only");
    public static final MeteringType SINGLE_PHASE_MULTI_EXPORT_ONLY       = new MeteringType("Single Phase Multi Element Export only", "Single Phase Multi Element Export only");

    public static final MeteringType HV_METERING_EXPORT_IMPORT  = new MeteringType("HV Metering Export and Import", "HV Metering Export and Import");
    public static final MeteringType LV_CT_METERING_EXPORT_IMPORT    = new MeteringType("LV CT Metering Export and Import", "LV CT Metering Export and Import");
    public static final MeteringType THREE_PHASE_EXPORT_IMPORT = new MeteringType("Three Phase Whole Current Export and Import", "Three Phase Whole Current Export and Import");
    public static final MeteringType SINGLE_PHASE_EXPORT_IMPORT    = new MeteringType("Single Phase Export and Import", "Single Phase Export and Import");
    public static final MeteringType SINGLE_PHASE_MULTI_EXPORT_IMPORT      = new MeteringType("Single Phase Multi Element Export and Import", "Single Phase Multi Element Export and Import");

    public static final MeteringType OTHER       = new MeteringType("Other", "Other");
	public static final MeteringType UNKNOWN     = new MeteringType("Unknown", "Unknown");

    private static final MeteringType[] METERING_TYPE_ARRAY =
      { HV_METERING_EXPORT_ONLY,
        LV_CT_METERING_EXPORT_ONLY,
        THREE_PHASE_EXPORT_ONLY,
        SINGLE_PHASE_EXPORT_ONLY,
        SINGLE_PHASE_MULTI_EXPORT_ONLY,

        HV_METERING_EXPORT_IMPORT,
        LV_CT_METERING_EXPORT_IMPORT,
        THREE_PHASE_EXPORT_IMPORT,
        SINGLE_PHASE_EXPORT_IMPORT,
        SINGLE_PHASE_MULTI_EXPORT_IMPORT,
		UNKNOWN,
        OTHER
      };

    public static final List<? extends Object> METERING_TYPES =
      Collections.unmodifiableList(Arrays.asList(METERING_TYPE_ARRAY));

    private MeteringType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

