/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/NameTitle.java-arc   1.1   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the NameTitle Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class NameTitle extends Enumeration 
                              implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the enumerations.
	 */
	 public static final NameTitle DR  = new NameTitle("Dr" , "Dr");
	 public static final NameTitle MS  = new NameTitle("Ms" , "Ms");
	 public static final NameTitle MRS = new NameTitle("Mrs" , "Mrs");
	 public static final NameTitle MR  = new NameTitle("Mr" , "Mr");
	 public static final NameTitle MISS= new NameTitle("Miss" , "Miss");


    private static final NameTitle[] NAME_TITLE_ARRAY =
      { DR, 
        MS, 
        MRS,
        MR,
        MISS
      };

    public static final List<? extends Object> NAME_TITLES =
      Collections.unmodifiableList(Arrays.asList(NAME_TITLE_ARRAY));

    private NameTitle(String code, 
                     String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

