package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class NotificationStatusType extends Enumeration implements Comparable<Object>, java.io.Serializable {

	public int count = 0;

	public static final NotificationStatusType SO_REQUESTED = new NotificationStatusType("SO Requested", "SO Requested");
	public static final NotificationStatusType SO_REJECTED = new NotificationStatusType("SO Rejected", "SO Rejected");
	public static final NotificationStatusType SO_COMPLETION = new NotificationStatusType("SO Completion", "SO Completion");
	public static final NotificationStatusType ACCEPTED_BY_NOTIFIED_PARTY = new NotificationStatusType("Accepted by Notified Party", "Accepted by Notified Party");
	public static final NotificationStatusType REJECTION_BY_NOTIFIED_PARTY = new NotificationStatusType("Rejection by Notified Party", "Rejection by Notified Party");
	public static final NotificationStatusType NOTIFIED_PARTY_STOPPED = new NotificationStatusType("Notified Party Stopped", "Notified Party Stopped");

	private static final NotificationStatusType[] NOTIFICATION_STATUS_ARRAY = { SO_REQUESTED, SO_REJECTED, SO_COMPLETION, ACCEPTED_BY_NOTIFIED_PARTY,REJECTION_BY_NOTIFIED_PARTY, NOTIFIED_PARTY_STOPPED };

	public static final List<? extends Object> NOTIFICATION_STATUS = Collections.unmodifiableList(Arrays.asList(NOTIFICATION_STATUS_ARRAY));

	private NotificationStatusType(String code, String description) {
		this.code = code;
		this.description = description;
		this.number = ++count;
	}

	public String toString() {
	  return code + "-" + description;
	}

}
