/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/OnOff.java-arc   1.0   12 Apr 2005 10:32:06   RayanS  $
 * $Revision:   1.0  $
 * $Date:   12 Apr 2005 10:32:06  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 03-Oct-2012    W.Mills           8081 - Java 7 upgrade
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author  Rayan Stephan
 * @version 0.1, Feb 23, 2005
 */

public class OnOff extends Enumeration implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

    /**
		  * The following define the enumerations.
		  */
    public static final OnOff ON  = new OnOff("ON" , "On");
    public static final OnOff OFF = new OnOff("OFF", "Off");

    private static final OnOff[] ONOFF_ARRAY =
      { ON,
        OFF
      };

    public static final List ONOFF =
      Collections.unmodifiableList(Arrays.asList(ONOFF_ARRAY));

    private OnOff(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

