 /**
  * OneWayNotificationName.java
  *
  * The Copyright of this work is vested in the Australian Energy  
  * Market Operator Limited and the software is issued in confidence
  * for the purpose only for which it is supplied. It must not be
  * reproduced in whole or in part or used for tendering or manufacturing
  * purposes except under an agreement or with the consent in writing of
  * the Australian Energy Market Operator Limited and then
  * only on the condition that this notice is included in any such
  * reproduction.  No information as to the contents or subject matter of
  * this software or any part thereof arising directly or indirectly there
  * from shall be given orally or in writing or communicated in any manner
  * whatsoever to any third party being an individual firm or company or
  * any employee thereof without the prior consent in writing of the 
  * Australian Energy Market Operator Limited.
  *
  * Copyright Australian Energy Market Operator Limited. 2011
  *
  * Modification History
  *
  * Date Changed   Changed By        Description
  * ------------   ----------        -----------
  * 18-Mar-2011    Eddie Graham      Created.
  * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
  */

package com.capgemini.nemmco.b2bb.enums;
    
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class OneWayNotificationName extends Enumeration implements Comparable<Object>, java.io.Serializable {
   
   private static int count = 0;
  
   /**
    * The following define the enumerations.
    */
   public static final OneWayNotificationName MXN = new OneWayNotificationName("MXN", "MXN");
   public static final OneWayNotificationName NTN = new OneWayNotificationName("NTN", "NTN");

   private static final OneWayNotificationName[] ONE_WAY_NOTIFICATION_NAME_ARRAY =
      { MXN,
        NTN
      };

   public static final List<? extends Object> ONE_WAY_NOTIFICATION_NAME_CODES =
      Collections.unmodifiableList(Arrays.asList(ONE_WAY_NOTIFICATION_NAME_ARRAY));

   private OneWayNotificationName(String code, String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }
}

