/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/PhoneServiceType.java-arc   1.5   Apr 14 2005 16:01:14   adij  $
 * $Revision:   1.5  $
 * $Date:   Apr 14 2005 16:01:14  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the PhoneServiceType Enumeration
 *
 * @author $Author:   adij  $
 * @version $Revision:   1.5  $ $Date:   Apr 14 2005 16:01:14  $
 */
public class PhoneServiceType extends Enumeration implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  /**
   * The following define the Transaction Type enumerations.
   */
  public static final PhoneServiceType FIXED = new PhoneServiceType("Fixed Voice", "Fixed Voice");
  public static final PhoneServiceType MOBILE = new PhoneServiceType("Mobile Voice", "Mobile Voice");
  public static final PhoneServiceType FAX = new PhoneServiceType("Fax", "Fax");
  public static final PhoneServiceType PAGER = new PhoneServiceType("Pager", "Pager");

  private static final PhoneServiceType[] PHONE_SERVICE_TYPE_ARRAY = { FIXED, MOBILE, FAX, PAGER };

  public static final List<? extends Object> PHONE_SERVICE_TYPES = Collections.unmodifiableList(Arrays.asList(PHONE_SERVICE_TYPE_ARRAY));

  private PhoneServiceType(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

