/*
* PlannedInterruptionReasons.java
*
* The Copyright of this work is vested in the Australian Energy Market
* Operator (AEMO) and the software is issued in confidence for the purpose
* only for which it is supplied. It must not be reproduced in whole or in
* part or used for tendering or manufacturing purposes except under an
* agreement or with the consent in writing of AEMO and then only on the
* condition that this notice is included in any such reproduction.
* No information as to the contents or subject matter of this software or
* any part thereof arising directly or indirectly there from shall be
* given orally or in writing or communicated in any manner whatsoever to
* any third party being an individual firm or company or any employee
* thereof without the prior consent in writing of AEMO.
*
* Copyright Australian Energy Market Operator Limited. 2017
*
* Modification History
*
* Date Changed   Changed By        Description
* ------------   ----------        -----------
* 29-Jun-2017    Harpreet Kaur     Created
*/


package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class PlannedInterruptionReasons extends Enumeration implements Comparable<Object>, java.io.Serializable {
   // Public constants
   private static int count = 0;

   /**
    * The following define the enumerations.
    */
   public static final PlannedInterruptionReasons DISTRIBUTION_WORKS              = new PlannedInterruptionReasons("Distribution Works", "Distribution Works");
   public static final PlannedInterruptionReasons METER_EXCHANGE_INDIVIDUAL       = new PlannedInterruptionReasons("Meter Exchange - Individual", "Meter Exchange - Individual");
   public static final PlannedInterruptionReasons METER_EXCHANGE_ROLLOUT          = new PlannedInterruptionReasons("Meter Exchange - Rollout", "Meter Exchange - Rollout");
   public static final PlannedInterruptionReasons METER_FAULT_INVESTIGATION       = new PlannedInterruptionReasons("Meter Fault Investigation", "Meter Fault Investigation");
   public static final PlannedInterruptionReasons METER_REPLACEMENT               = new PlannedInterruptionReasons("Meter Replacement - Family Maintenance", "Meter Replacement - Family Maintenance");
   public static final PlannedInterruptionReasons METER_TEST                      = new PlannedInterruptionReasons("Meter Test", "Meter Test");
   public static final PlannedInterruptionReasons OTHER                           = new PlannedInterruptionReasons("Other", "Other");

   private static final PlannedInterruptionReasons[] PLANNED_INTERRUPTION_REASONS_ARRAY = {
      DISTRIBUTION_WORKS,
      METER_EXCHANGE_INDIVIDUAL,
      METER_EXCHANGE_ROLLOUT,
      METER_FAULT_INVESTIGATION,
      METER_REPLACEMENT,
      METER_TEST,
      OTHER
   };

   public static final List<? extends Object> PLANNED_INTERRUPTION_REASONS = Collections.unmodifiableList(Arrays.asList(PLANNED_INTERRUPTION_REASONS_ARRAY));

   private PlannedInterruptionReasons(String code,String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }

}
