/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/Reason.java-arc   1.1   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 * 17-Jul-2013    Eddie Graham   Defect 2168. Add new constants NO_RESPONSE_TO_REJECTED_CDN,TRANSFER_COMPLETE_NO_CDN_RECEIVED,
 *                               NEW_CONNECTION_NO_CDN_RECEIVED,DATA_QUALITY_ISSUE.
 * 16-Dec-2013    Eddie Graham   Defect 3816. Add new constant REC_CONFIRM_NO_SENSITIVELOAD.                               
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Reason Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:23:42  $
 */
public class Reason extends Enumeration 
                          implements Comparable<Object>, java.io.Serializable {
  
  // Public constants
  private static int count = 0;
  
  /**
   * The following define the enumerations.
   */
  public static final Reason RETURNED_MAIL = new Reason("Returned Mail", "Returned Mail");
  public static final Reason MISSING_CUSTOMER_DETAILS = new Reason("Missing Customer Details", "Missing Customer Details");
  public static final Reason CONFIRM_LIFE_SUPPORT = new Reason("Confirm Life Support", "Confirm Life Support");
  public static final Reason OTHER = new Reason("Other", "Other");
  public static final Reason NO_RESPONSE_TO_REJECTED_CDN = new Reason("No response to rejected CDN", "No response to rejected CDN");
  public static final Reason TRANSFER_COMPLETE_NO_CDN_RECEIVED = new Reason("Transfer Complete, no CDN Received", "Transfer Complete, no CDN Received");
  public static final Reason NEW_CONNECTION_NO_CDN_RECEIVED = new Reason("New Connection, no CDN Received", "New Connection, no CDN Received");
  public static final Reason DATA_QUALITY_ISSUE = new Reason("Data Quality Issue", "Data Quality Issue");
  public static final Reason REC_CONFIRM_NO_SENSITIVELOAD = new Reason("Rec - confirm no SensitiveLoad", "Rec - confirm no SensitiveLoad");
    
  private static final Reason[] REASON_ARRAY =
  { RETURNED_MAIL,
    MISSING_CUSTOMER_DETAILS,
    CONFIRM_LIFE_SUPPORT,
    OTHER,
    NO_RESPONSE_TO_REJECTED_CDN,
    TRANSFER_COMPLETE_NO_CDN_RECEIVED,
    NEW_CONNECTION_NO_CDN_RECEIVED,
    DATA_QUALITY_ISSUE,
    REC_CONFIRM_NO_SENSITIVELOAD    
  };

  public static final List<? extends Object> REASONS =
    Collections.unmodifiableList(Arrays.asList(REASON_ARRAY));

    
  private Reason(String code, 
                 String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
  
  public String toString() {
    return code + "-" + description;
  }
  
}