/*
 * RemovedEquipmentType.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By       Description
 * ------------   ----------       -----------
 * 11-Jul-2017    SP                Created as part of the SMP new screens
 */
package com.capgemini.nemmco.b2bb.enums;

import java.io.Serializable;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class RemovedEquipmentType extends Enumeration implements Comparable<Object>, Serializable {
   // Public constants
   private static int count = 0;

    /**
        * The following define the enumerations.
        */
    public static final RemovedEquipmentType BASIC_METER           = new RemovedEquipmentType("Basic Meter", "Basic Meter");
    public static final RemovedEquipmentType INTERVAL_METER     = new RemovedEquipmentType("Interval Meter", "Interval Meter");
    public static final RemovedEquipmentType NETWORK_DEVICE          = new RemovedEquipmentType("Network Device", "Network Device");
    public static final RemovedEquipmentType CONTROL_EQUIPMENT     = new RemovedEquipmentType("Control Equipment", "Control Equipment");
    public static final RemovedEquipmentType INSTRUMENT_TRANSFORMER           = new RemovedEquipmentType("Instrument Transformer", "Instrument Transformer");




    private static final RemovedEquipmentType[] REMOVED_EQUIPMENT_TYPE_ARRAY =
      { BASIC_METER,
   INTERVAL_METER,
   NETWORK_DEVICE,
   CONTROL_EQUIPMENT,
   INSTRUMENT_TRANSFORMER

      };

    public static final List<? extends Object> REMOVED_EQUIPMENT_TYPES =
      Collections.unmodifiableList(Arrays.asList(REMOVED_EQUIPMENT_TYPE_ARRAY));

    private RemovedEquipmentType(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }
}
