/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ResponseType.java-arc   1.4   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.4  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the priority Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class ResponseType extends Enumeration 
                          implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the Transaction Type enumerations.
	 */
	 public static final ResponseType CLOSURE     = new ResponseType("Closure", "Closure");
   public static final ResponseType APPOINTMENT     = new ResponseType("Appointment", "Appointment");

    private static final ResponseType[] RESPONSE_TYPE_ARRAY =
      { CLOSURE,
        APPOINTMENT
      };

    public static final List<? extends Object> RESPONSE_TYPE =
      Collections.unmodifiableList(Arrays.asList(RESPONSE_TYPE_ARRAY));

    private ResponseType(String code, 
                     String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

