/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ServiceOrderType.java-arc   1.4   26 Apr 2005 14:22:46   RayanS  $
 * $Revision:   1.4  $
 * $Date:   26 Apr 2005 14:22:46  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 * 27-June-2017   NG             7135 - PoC SMP Changes
 * 12-Jul-2017    HAM            PoC SMP Changes
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   26 Apr 2005 14:22:46  $
 */

public class ServiceOrderType extends Enumeration
                              implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

    /**
		  * The following define the enumerations.
		  */
    public static final ServiceOrderType SUPP_SRV_WRK       = new ServiceOrderType("Supply Service Works", "Supply Service Works");
    public static final ServiceOrderType METER_SRV_WRK      = new ServiceOrderType("Metering Service Works", "Metering Service Works");
    public static final ServiceOrderType RE_ENERGISATION    = new ServiceOrderType("Re-energisation", "Re-energisation");
    public static final ServiceOrderType DE_ENERGISATION    = new ServiceOrderType("De-energisation", "De-energisation");
    public static final ServiceOrderType SPECIAL_READ       = new ServiceOrderType("Special Read", "Special Read");
    public static final ServiceOrderType MISC               = new ServiceOrderType("Miscellaneous", "Miscellaneous");
    public static final ServiceOrderType CANCEL             = new ServiceOrderType("Cancel", "Cancel");


    private static final ServiceOrderType[] SERVICE_ORDER_TYPE_ARRAY =
      { SUPP_SRV_WRK,
        METER_SRV_WRK,
        RE_ENERGISATION,
        DE_ENERGISATION,
        SPECIAL_READ,
        MISC,
        CANCEL
      };

    public static final List<? extends Object> SERVICE_ORDER_TYPES =
      Collections.unmodifiableList(Arrays.asList(SERVICE_ORDER_TYPE_ARRAY));

    private ServiceOrderType(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

    public boolean isServiceOrderTypeExists(String value) {
        for(ServiceOrderType serviceOrderType : Arrays.asList(SERVICE_ORDER_TYPE_ARRAY)) {
            if(serviceOrderType.getCode().equals(value)) {
                return true;
            }
        }
        return false;
    }     
}

