/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ServiceTime.java-arc   1.3   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class ServiceTime extends Enumeration 
                         implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final ServiceTime ANY_TIME           = new ServiceTime("Any Time", "Any Time");
    public static final ServiceTime BUSINESS_HOURS     = new ServiceTime("Business Hours", "Business Hours");
    public static final ServiceTime NON_BUSINESS_HOURS = new ServiceTime("Non-Business Hours", "Non-Business Hours");

    private static final ServiceTime[] SERVICE_TIME_ARRAY =
      { ANY_TIME,
        BUSINESS_HOURS,
        NON_BUSINESS_HOURS
      };

    public static final List<? extends Object> SERVICE_TIME_TYPES =
      Collections.unmodifiableList(Arrays.asList(SERVICE_TIME_ARRAY));

    private ServiceTime(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

