/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/State.java-arc   1.1   11 Apr 2005 11:10:46   RayanS  $
 * $Revision:   1.1  $
 * $Date:   11 Apr 2005 11:10:46  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */
 
package com.capgemini.nemmco.b2bb.enums;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the State Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   11 Apr 2005 11:10:46  $
 */
public class State extends Enumeration implements Comparable<Object>, java.io.Serializable 
{
  private static int count = 0;
  /**
   * The following define the Transaction Type enumerations.
   */
  public static final State AAT = new State("AAT", "AAT");
  public static final State ACT = new State("ACT", "ACT");
  public static final State NSW = new State("NSW", "NSW");
  public static final State NT = new State("NT", "NT");
  public static final State QLD = new State("QLD", "QLD");
  public static final State SA = new State("SA", "SA");
  public static final State TAS = new State("TAS", "TAS");
  public static final State VIC = new State("VIC", "VIC");
  public static final State WA = new State("WA", "WA");
  

  private static final State[] STATE_ARRAY = { AAT, ACT, NSW, NT, QLD, SA, TAS, VIC, WA };

  public static final List<? extends Object> STATES = Collections.unmodifiableList(Arrays.asList(STATE_ARRAY));
  
  /**
   * Return the State object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static State getSortOrder(String code) {
    for (int i = 0; i < STATES.size(); i++) {
      if ((((Enumeration) STATES.get(i)).getCode()).equals(code))
          return (State) STATES.get(i);
    }
    return null;
  }

  private State(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}