/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/StreetType.java-arc   1.3   15 Apr 2005 14:11:02   hendyl  $
 * $Revision:   1.3  $
 * $Date:   15 Apr 2005 14:11:02  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Defect 1514 : 04-01-07 : Bob Jones : Added new street types that were in Enumerations.xsd.
 * Defect 4323 : 08-05-07 : Bob Jones : Defect 1514 addition: Add new StreetType VLL - Villa 
 *                                      as communicated by Nada.
 * Defect 4323 : 16-05-07 : Bob Jones : Defect 1514: Fix alphabetical order of street types 
 *                                      displayed and misspelling of CIRCUS as CICRUS.
 * Defect 7366 : 04-07-11 : Eddie Graham : Derive enumerations from aseXML Enumerations schema file.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import com.sun.xml.xsom.XSFacet;
import com.sun.xml.xsom.XSRestrictionSimpleType;
import com.sun.xml.xsom.XSSchema;

import com.sun.xml.xsom.XSSimpleType;

import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 * Defines the Enumeration
 *
 * @author $Author:   hendyl  $
 * @version $Revision:   1.3  $ $Date:   15 Apr 2005 14:11:02  $
 */

public class StreetType extends Enumeration 
                        implements Comparable<Object>, java.io.Serializable {
	// Public constants
   private static int count = 0;

   public static List<? extends Object> STREET_TYPES;  
 
   public static void setStreetType(XSSchema xsSchema) {
      StreetType[] streetType = null;    
   
      XSSimpleType st = xsSchema.getSimpleType("AustralianStreetType");

      if(st != null){
         XSRestrictionSimpleType restriction = st.asRestriction();
         
         if(restriction != null){
            Vector<StreetType> enumeration = new Vector<StreetType>();         
            Iterator<? extends XSFacet> i = restriction.getDeclaredFacets().iterator();
            while(i.hasNext()){
               XSFacet facet = (XSFacet)i.next();
               if(facet.getName().equals(XSFacet.FACET_ENUMERATION)){             
                  enumeration.add(new StreetType(facet.getValue().value,facet.getValue().value));
               }
            }
         
            if(enumeration.size() > 0){
               streetType = enumeration.toArray(new StreetType[]{});
               Arrays.sort(streetType);                 
               STREET_TYPES = Collections.unmodifiableList(Arrays.asList(streetType));            
            }
         }
      }
   } 

   private StreetType(String code, 
                 String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }
}

