/*
 * TransactionJSP.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 26-Apr-2005    RayanS            Created
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 * 15-Jun-2017    SP                SMP  workpkg7b- adding the RemoteAccess Request screen
 * 27-Jun-2017    NG                7135 - PoC SMP Changes
 * 30-Jun-2017    Harpreet Kaur     7135 Package 7B:Add new constant PLANNED_INTERRUPT_NOT
 * 10-Jul-2017    W.Mills           7378 Transaction Type drop down is blank
 * 10-Jul-2017    Harpreet Kaur    7135 Package 7B:Add new constant METER_FAULT_AND_ISSUE_NOT
 * 10-Jul-2017    SP                  SMP  workpkg7b- adding the Notice Of metering works
 * 18-Jul-2017    Harpreet Kaur    7135 Package 7B:Add new constant SOR_SPECIAL_READ_FINAL
 * 28-Jul-2017    Harpreet Kaur    7135 Package 7B: Changes doen for SOR Meter Service Works screens as part of POC SMP
 * 01-Aug-2017    Harpreet Kaur    7135 Package 7B: Changes doen for SOR Re-Energisation and SOR_DEENERGISATION screens as part of POC SMP
 * 09-Aug-2017    Harpreet Kaur    7135 Package 7B: Changes done for SOR Re-Energisation, De-Energisation and SpecialRead  screens as part of POC SMP
 * 31-Oct-2017    Harpreet Kaur    7135 Package 7B: Defect# 8298 Re-Energisation : New Reading Required changes
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the mapping of transactions to JSPs
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.12  $ $Date:   26 Apr 2005 14:22:46  $
 */
public class TransactionJSP extends Enumeration implements Comparable<Object>, java.io.Serializable {


  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;
   public static final TransactionJSP CUST_DETAIL_NOT             = new TransactionJSP("CustDetailNotification", "Customer Details Notification", "B2BB_U202_CustomerDetailsNotification.jsp", TransactionType.CUST_DETAIL_NOT, B2BBEntity.B2BB_U202_CDN);
   public static final TransactionJSP METER_DATA_VERIFY_REQ       = new TransactionJSP("MeterDataVerifyRequest", "Verify Meter Data Request", "B2BB_U202_MeterDataVerifyRequest.jsp", TransactionType.METER_DATA_VERIFY_REQ, B2BBEntity.B2BB_U202_MDVR);
   public static final TransactionJSP PROVIDE_METER_DATA_REQ      = new TransactionJSP("ProvideMeterDataRequest", "Provide Meter Data Request", "B2BB_U202_ProvideMeterDataRequest.jsp", TransactionType.PROVIDE_METER_DATA_REQ, B2BBEntity.B2BB_U202_PMDR);
   public static final TransactionJSP SITE_ACCESS_REQ             = new TransactionJSP("SiteAccessRequest", "Site Access Request", "B2BB_U202_SiteAccessRequest.jsp", TransactionType.SITE_ACCESS_REQ, B2BBEntity.B2BB_U202_SACCESSR);
   public static final TransactionJSP SITE_ACCESS_NOT             = new TransactionJSP("SiteAccessNotification", "Site Access Notification", "B2BB_U202_SiteAccessNotification.jsp", TransactionType.SITE_ACCESS_NOT, B2BBEntity.B2BB_U202_SACCESSN);
   public static final TransactionJSP SITE_ADDRESS_NOT            = new TransactionJSP("SiteAddressNotification", "Site Address Notification", "B2BB_U202_SiteAddressNotification.jsp", TransactionType.SITE_ADDRESS_NOT, B2BBEntity.B2BB_U202_SADDRESSN);

   public static final TransactionJSP SOR_ALLOCATE_NMI            = new TransactionJSP("SORAllocateNMI", "Supply Service Works Allocate NMI", "B2BB_U202_SORAllocateNMI.jsp", TransactionType.SOR_ALLOCATE_NMI, B2BBEntity.B2BB_U202_SORALLOCATENMI);
   public static final TransactionJSP SOR_NEW_CONNECTION          = new TransactionJSP("SORNewConnection", "Supply Service Works Establish Permanent", "B2BB_U202_SORNewConnection.jsp", TransactionType.SOR_NEW_CONNECTION, B2BBEntity.B2BB_U202_SORNEWCONN);
   public static final TransactionJSP SOR_NEW_CONNECTION_T        = new TransactionJSP("SORNewConnectionTemp", "Supply Service Works Establish Temporary", "B2BB_U202_SORNewConnectionTemp.jsp", TransactionType.SOR_NEW_CONNECTION_T, B2BBEntity.B2BB_U202_SORNEWCONN_T);
   public static final TransactionJSP SOR_NEW_CONNECTION_TP       = new TransactionJSP("SORNewConnectionTempPmt", "Supply Service Works Establish Temporary In Permanent", "B2BB_U202_SORNewConnectionTempPerm.jsp", TransactionType.SOR_NEW_CONNECTION_TP, B2BBEntity.B2BB_U202_SORNEWCONN_TP);
   public static final TransactionJSP SOR_NEW_SUPP_ALT            = new TransactionJSP("SORSupplyAlteration", "Supply Service Works Supply Alteration", "B2BB_U202_SORNewConnectionSupplyAlteration.jsp", TransactionType.SOR_SUPPLY_ALTERATION, B2BBEntity.B2BB_U202_SORNEWCONN_SUPP_ALT);
   public static final TransactionJSP SOR_SUPPLY_ABOLISHMENT      = new TransactionJSP("SORSupplyAbolishment", "Supply Service Works Supply Abolishment", "B2BB_U202_SORSupplyAbolishment.jsp", TransactionType.SOR_SUPPLY_ABOLISHMENT, B2BBEntity.B2BB_U202_SORSABOLISH);
   public static final TransactionJSP SOR_TEMP_ISOLATION          = new TransactionJSP("SORTempIsolation", "Supply Service Works Temporary Isolation", "B2BB_U202_SORSupplyTemporaryIsolation.jsp", TransactionType.SOR_TEMP_ISOLATION, B2BBEntity.B2BB_U202_SORTEMPISOLATION);
   public static final TransactionJSP SOR_TEMP_ISOLATION_GRP      = new TransactionJSP("SORTempIsolationGrp", "Supply Service Works Temporary Isolation-Group Supply", "B2BB_U202_SORSupplyTemporaryIsolationGroup.jsp", TransactionType.SOR_TEMP_ISOLATION_GRP, B2BBEntity.B2BB_U202_SORTEMPISOLATION_GROUP);
   public static final TransactionJSP SOR_TARIFF_CHANGE           = new TransactionJSP("SORTariffChange", "Supply Service Works Tariff Change", "B2BB_U202_SORTariffChange.jsp", TransactionType.SOR_TARIFF_CHANGE, B2BBEntity.B2BB_U202_SORSTARRIFCHANGE);

   public static final TransactionJSP SOR_REENERGISATION          = new TransactionJSP("SORReenergisation", "Service Order Re-energisation Remote", "B2BB_U202_SORReenergisation.jsp", TransactionType.SOR_REENERGISATION, B2BBEntity.B2BB_U202_SORRENER);
   public static final TransactionJSP SOR_REENERGISATION_PHY_VISIT          = new TransactionJSP("SORReenergisationPhyVisit", "Service Order Re-energisation Physical Visit", "B2BB_U202_SORReenergisationPhyVisit.jsp", TransactionType.SOR_REENERGISATION_PHY_VISIT, B2BBEntity.B2BB_U202_SORRENERPHYVISIT);
   public static final TransactionJSP SOR_REENERGISATION_RETRO_MOVEIN          = new TransactionJSP("SORReenergisationRetroMoveIn", "Service Order Re-energisation Move In", "B2BB_U202_SORReenergisationRetroMoveIn.jsp", TransactionType.SOR_REENERGISATION_RETRO_MOVEIN, B2BBEntity.B2BB_U202_SORRENERRETROMOVEIN);
   public static final TransactionJSP SOR_REENERGISATION_REC_DISCR          = new TransactionJSP("SORReenergisationRecDiscr", "Service Order Re-energisation Recipient Descretion", "B2BB_U202_SORReenergisationRecDiscr.jsp", TransactionType.SOR_REENERGISATION_REC_DISCR, B2BBEntity.B2BB_U202_SORRENERRECDISCR);
   public static final TransactionJSP SOR_REENERGISATION_AFT_DISCONN          = new TransactionJSP("SORReenergisationAftDisconn", "Service Order Re-energisation After Disconnection", "B2BB_U202_SORReenergisationAftDisconn.jsp", TransactionType.SOR_REENERGISATION_AFT_DISCONN, B2BBEntity.B2BB_U202_SORRENERAFTDISCONN);
   public static final TransactionJSP SOR_REENERGISATION_MOVEIN          = new TransactionJSP("SORReenergisationMoveIn", "Service Order Re-energisation Move In", "B2BB_U202_SORReenergisationMoveIn.jsp", TransactionType.SOR_REENERGISATION_MOVEIN, B2BBEntity.B2BB_U202_SORRENERMOVEIN);
   public static final TransactionJSP SOR_REENERGISATION_NEW_READ         = new TransactionJSP("SORReenergisationNewRead", "Service Order Re-energisation New Reading Required", "B2BB_U202_SORReenergisationNewReadReq.jsp", TransactionType.SOR_REENERGISATION_NEW_READ, B2BBEntity.B2BB_U202_SORRENERNEWREADREQ);

   public static final TransactionJSP SOR_DEENERGISATION          = new TransactionJSP("SORDeenergisation", "Service Order De-energisation Disconnect at Pillar-Box PitOrPole-Top", "B2BB_U202_SORDeenergisation.jsp", TransactionType.SOR_DEENERGISATION, B2BBEntity.B2BB_U202_SORDENER);
   public static final TransactionJSP SOR_DEENERGISATION_REMOTE  = new TransactionJSP("SORDeenergisationRemote", "Service Order De-energisation Remote",  "B2BB_U202_SORDeenergisationRemote.jsp", TransactionType.SOR_DEENERGISATION_REMOTE, B2BBEntity.B2BB_U202_SORDENERREMOTE);
   public static final TransactionJSP SOR_DEENERGISATION_LOC_MET_DISCONN  = new TransactionJSP("SORDeenergisationLocMetDisconn", "Service Order De-energisation Local Meter Disconnection","B2BB_U202_SORDeenergisationLocMetDisconn.jsp", TransactionType.SOR_DEENERGISATION_LOC_MET_DISCONN,  B2BBEntity.B2BB_U202_SORDENERLOCMETDIS);
   public static final TransactionJSP SOR_DEENERGISATION_REC_DISCR = new TransactionJSP("SORDeenergisationRecDiscr", "Service Order De-energisation Recipient Discretion", "B2BB_U202_SORDeenergisationRecDiscr.jsp",   TransactionType.SOR_DEENERGISATION_REC_DISCR, B2BBEntity.B2BB_U202_SORDENERRECDISC);
   public static final TransactionJSP SOR_DEENERGISATION_REMOVE_FUSE = new TransactionJSP("SORDeenergisationRemoveFuse","Service Order De-energisation Remove Fuse", "B2BB_U202_SORDeenergisationRemoveFuse.jsp",  TransactionType.SOR_DEENERGISATION_REMOVE_FUSE, B2BBEntity.B2BB_U202_SORDENERREMOVEFUSE);

   public static final TransactionJSP SOR_SPECIAL_READ                            = new TransactionJSP("SORSpecialRead","Service Order Special Read (not Check or Final)",  "B2BB_U202_SORSpecialRead.jsp",  TransactionType.SOR_SPECIAL_READ,  B2BBEntity.B2BB_U202_SORSREAD);
   public static final TransactionJSP SOR_SPECIAL_READ_FINAL                      = new TransactionJSP("SORSpecialReadFinal","Service Order Special Read Final Read", "B2BB_U202_SORSpecialReadFinal.jsp", TransactionType.SOR_SPECIAL_READ_FINAL, B2BBEntity.B2BB_U202_SORSREADFINAL);
   public static final TransactionJSP SOR_SPECIAL_READ_CHECK                      = new TransactionJSP("SORSpecialReadCheck","Service Order Special Read Check Read", "B2BB_U202_SORSpecialReadCheck.jsp",  TransactionType.SOR_SPECIAL_READ_CHECK,  B2BBEntity.B2BB_U202_SORSREADCHECK);

   public static final TransactionJSP SOR_MSW_INSTALL_METER       = new TransactionJSP("SORMetServWrksInstallMeter", "Meter Service Works Install Meter", "B2BB_U202_SORMetServWrksInstallMeter.jsp", TransactionType.SOR_MSW_INSTALL_METER, B2BBEntity.B2BB_U202_SORMSWINSTALL);
   public static final TransactionJSP SOR_MSW_MOVE_METER          = new TransactionJSP("SORMetServWrksMoveMeter", "Meter Service Works Move Meter", "B2BB_U202_SORMetServWrksMoveMeter.jsp", TransactionType.SOR_MSW_MOVE_METER, B2BBEntity.B2BB_U202_SORMSWMOVE);
   public static final TransactionJSP SOR_MSW_REMOVE_METER        = new TransactionJSP("SORMetServWrksRemoveMeter", "Meter Service Works Remove Meter", "B2BB_U202_SORMetServWrksRemoveMeter.jsp", TransactionType.SOR_MSW_REMOVE_METER, B2BBEntity.B2BB_U202_SORMSWREMOVE);
   public static final TransactionJSP SOR_MSW_EXCHANGE_METER      = new TransactionJSP("SORMetServWrksExchangeMeter", "Meter Service Works Exchange Meter", "B2BB_U202_SORMetServWrksExchangeMeter.jsp", TransactionType.SOR_MSW_EXCHANGE_METER, B2BBEntity.B2BB_U202_SORMSWEXCHANGE);
   public static final TransactionJSP SOR_MSW_INSTALL_CLOAD       = new TransactionJSP("SORMetServWrksInstallCLoad", "Meter Service Works Install Controlled Load", "B2BB_U202_SORMetServWrksInstallCLoad.jsp", TransactionType.SOR_MSW_INSTALL_CLOAD, B2BBEntity.B2BB_U202_SORMSWCLOAD);
   public static final TransactionJSP SOR_MSW_METER_RECONFIG      = new TransactionJSP("SORMetServWrksMeterReconfig", "Meter Service Works Meter Reconfiguration", "B2BB_U202_SORMeterReconfiguration.jsp", TransactionType.SOR_MSW_METER_RECONFIG, B2BBEntity.B2BB_U202_SORMRECONFIG);
   public static final TransactionJSP SOR_MSW_METER_INV_INS       = new TransactionJSP("SORMetServWrksInvInspect", "Meter Service Works Meter Investigation-Inspect", "B2BB_U202_SORMeterReconfigurationInvIns.jsp",  TransactionType.SOR_MSW_METER_INV_INS, B2BBEntity.B2BB_U202_SORMRECONFIG);
   public static final TransactionJSP SOR_MSW_METER_INV_TEST      = new TransactionJSP("SORMetServWrksInvTest", "Meter Service Works Meter Investigation-Test", "B2BB_U202_SORMeterReconfigurationInvTest.jsp",  TransactionType.SOR_MSW_METER_INV_TEST, B2BBEntity.B2BB_U202_SORMRECONFIG);
   public static final TransactionJSP SOR_MSW_RESEAL              = new TransactionJSP("SORMetServWrksReseal", "Meter Service Works Reseal Device", "B2BB_U202_SORMeterReconfigurationReseal.jsp", TransactionType.SOR_MSW_RESEAL, B2BBEntity.B2BB_U202_SORMRECONFIG);
   public static final TransactionJSP SOR_MSW_CHG_TSWITCH         = new TransactionJSP("SORMetServWrksChgTSwitch", "Meter Service Works Change Timeswitch Settings", "B2BB_U202_SORMeterChangTimeswitchSetting.jsp", TransactionType.SOR_MSW_CHG_TSWITCH, B2BBEntity.B2BB_U202_SORMRECONFIG);

   public static final TransactionJSP SOR_MISCELLANEOUS           = new TransactionJSP("SORMiscellaneous", "Service Order Request Miscellaneous", "B2BB_U202_SORMiscellaneous.jsp", TransactionType.SOR_MISCELLANEOUS, B2BBEntity.B2BB_U202_SORMISS);
   public static final TransactionJSP SOR_CANCEL                  = new TransactionJSP("SORCancel", "Service Order Request Cancel", "B2BB_U202_SORCancel.jsp", TransactionType.SOR_CANCEL, B2BBEntity.B2BB_U202_SORCANCL);
   public static final TransactionJSP SOR_RESPONSE                = new TransactionJSP("SORResponse", "Service Order Response", "B2BB_U203_SORResponse.jsp", TransactionType.SOR_RESPONSE, B2BBEntity.B2BB_U202_SORESPONSE);

   public static final TransactionJSP ONE_WAY_NOT                 = new TransactionJSP("OneWayNotification", "One Way Notification", "B2BB_U202_OneWayNotification.jsp", TransactionType.ONE_WAY_NOT, B2BBEntity.B2BB_U202_OWN);
   public static final TransactionJSP REMOTE_SERVICE_REQ = new TransactionJSP("RemoteServiceRequest", "Remote Service Request", "B2BB_U202_RemoteServiceRequest.jsp", TransactionType. REMOTE_SERVICE_REQ, B2BBEntity.B2BB_U202_REMOTESERVICEREQ);
   public static final TransactionJSP REMOTE_SERVICE_RES = new TransactionJSP("RemoteServiceResponse", "Remote Service Response", "B2BB_U202_RemoteServiceResponse.jsp", TransactionType.REMOTE_SERVICE_RES, B2BBEntity.B2BB_U202_REMOTESERVICERES);
   public static final TransactionJSP PLANNED_INTERRUPT_NOT = new TransactionJSP("PlannedInterruptionNotification", "Planned Interruption Notification", "B2BB_U202_PlannedInterruptionNotification.jsp", TransactionType.PLANNED_INTERRUPT_NOT, B2BBEntity.B2BB_U202_PINTERRUPTN);
   public static final TransactionJSP METER_FAULT_AND_ISSUE_NOT = new TransactionJSP("MeterFaultAndIssueNotification", "Meter Fault And Issue Notification", "B2BB_U202_MeterFaultAndIssueNotification.jsp", TransactionType.METER_FAULT_AND_ISSUE_NOT, B2BBEntity.B2BB_U202_MFIN);
   public static final TransactionJSP NOTICE_OF_METERING_WORKS = new TransactionJSP("NoticeOfMeteringWorks", "Notice Of Metering Works", "B2BB_U202_NoticeOfMeteringWorks.jsp", TransactionType.NOTICE_OF_METERING_WORKS, B2BBEntity.B2BB_U202_NOTICEOFMETERINGWORKS);
    public static final TransactionJSP NOTIFIED_PARTY = new TransactionJSP("NotifiedParty", "Notified Party", "B2BB_U202_NotifiedParty.jsp", TransactionType.NOTIFIED_PARTY, B2BBEntity.B2BB_U202_NOTIFIPARTY);
   public static final TransactionJSP PEER_TO_PEER = new TransactionJSP("PTPDataExchange", "Peer To Peer", "B2BB_U202_PeerToPeerDataExchange.jsp", TransactionType.PEER_TO_PEER, B2BBEntity.B2BB_U202_PEERTOPEER);

  // 23-Jan-2009 Eddie Graham Defect 4793. Add new constant ONE_WAY_NOT.
  private static final TransactionJSP[] TRANS_JSP = {
      SOR_ALLOCATE_NMI,
      SOR_NEW_CONNECTION,
      SOR_NEW_CONNECTION_T,
      SOR_NEW_CONNECTION_TP,
      SOR_NEW_SUPP_ALT,
      SOR_SUPPLY_ABOLISHMENT,
      SOR_TEMP_ISOLATION,
      SOR_TEMP_ISOLATION_GRP,
      SOR_TARIFF_CHANGE,

      //REENERGISATION
      SOR_REENERGISATION,
      SOR_REENERGISATION_PHY_VISIT,
      SOR_REENERGISATION_RETRO_MOVEIN,
      SOR_REENERGISATION_REC_DISCR,
      SOR_REENERGISATION_AFT_DISCONN,
      SOR_REENERGISATION_MOVEIN,
      SOR_REENERGISATION_NEW_READ,


     //DEENERGISATION
      SOR_DEENERGISATION,
      SOR_DEENERGISATION_REMOTE,
      SOR_DEENERGISATION_LOC_MET_DISCONN,
      SOR_DEENERGISATION_REC_DISCR,
      SOR_DEENERGISATION_REMOVE_FUSE,



      //SPECIAL_READ
      SOR_SPECIAL_READ,
      SOR_SPECIAL_READ_FINAL,
	  SOR_SPECIAL_READ_CHECK,
      //SOR_METER_RECONFIG,
      //SOR_METER_INVESTIGATION,

      // NG - 27/06/2017 The following are needed as part of Meter Service Works of POC. Will need to handle during development.
      SOR_MSW_INSTALL_METER,
      SOR_MSW_MOVE_METER,
      SOR_MSW_REMOVE_METER,
      SOR_MSW_EXCHANGE_METER,
      SOR_MSW_INSTALL_CLOAD,
      SOR_MSW_METER_RECONFIG,
      SOR_MSW_METER_INV_INS,
      SOR_MSW_METER_INV_TEST,
      SOR_MSW_RESEAL,
      SOR_MSW_CHG_TSWITCH,

      SOR_MISCELLANEOUS,
      SOR_RESPONSE,
      SOR_CANCEL,
      CUST_DETAIL_NOT,
      SITE_ACCESS_REQ,
      SITE_ACCESS_NOT,
      SITE_ADDRESS_NOT,
      PROVIDE_METER_DATA_REQ,
      METER_DATA_VERIFY_REQ,
      REMOTE_SERVICE_REQ,
      REMOTE_SERVICE_RES,
      ONE_WAY_NOT,
      PLANNED_INTERRUPT_NOT,
      METER_FAULT_AND_ISSUE_NOT,
      NOTICE_OF_METERING_WORKS,
      NOTIFIED_PARTY
      ,PEER_TO_PEER
      };

  public static final List<TransactionJSP> TRANS_JSPS = Collections.unmodifiableList(Arrays.asList(TRANS_JSP));

  /**
   * Return the TransactionJSP object given by code (key)
   *
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static TransactionJSP getTransactionJSP(String code) {
     for (TransactionJSP jsp : TRANS_JSPS) {
      if (jsp.getCode().equals(code))
          return jsp;
    }
    return null;
  }

  /**
   * Return the TransactionJSP object given by code (key)
   *
   * @param transactionType
   *          The transactionType to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static TransactionJSP getTransactionJSP(TransactionType transactionType) {
    for (TransactionJSP jsp : TRANS_JSPS)
      if (jsp.getTransactionType() == transactionType)
        return jsp;
    return null;
  }

  private final String transactionJSP;
  private final TransactionType transactionType;
  private final B2BBEntity entity;

  private TransactionJSP(String code, String description, String transactionJSP, TransactionType transactionType, B2BBEntity entity) {
    this.code = code;
    this.description = description;
    this.transactionJSP = transactionJSP;
    this.transactionType = transactionType;
    this.entity = entity;
    this.number = ++count;
  }

  /**
   * @return Returns the transactionJSP.
   */
  public String getTransactionJSP() {
    return transactionJSP;
  }

  /**
   * @return Returns the transactionType.
   */
  public TransactionType getTransactionType() {
    return transactionType;
  }

  /**
   * @return Returns the entity.
   */
  public B2BBEntity getEntity() {
    return entity;
  }
}

