/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/TransactionType.java-arc   1.27   26 Apr 2005 14:22:46   RayanS  $
 * $Revision:   1.27  $
 * $Date:   26 Apr 2005 14:22:46  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 23-Jan-2009    Eddie Graham      Defect 4793. Add new constant ONE_WAY_NOT.
 * 03-Oct-2012    W.Mills           8081 - Java 7 upgrade
 * 27-Jun-2017    Harpreet Kaur    7135 Package 7B:Add new constant SITE_ACCESS_REQ
 * 30-Jun-2017    Harpreet Kaur    7135 Package 7B:Add new constant PLANNED_INTERRUPT_NOT
 * 10-Jul-2017    Harpreet Kaur    7135 Package 7B:Add new constant METER_FAULT_AND_ISSUE_NOT
 * 10-Jul-2017    SP               SMP  workpkg7b- adding the Notice Of metering works
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * A typesafe enumeration of the TransactionType TransactionGroup mapping available in the B2B Browser Application.
 *
 * Immutable, Thread safe, and resolves properly on deserialization.
 *
 * @author $Author:   AdiJ  $
 * @version $Revision:   1.1  $ $Date:   26 Apr 2005 14:22:46  $
 */
public final class TransactionTypeGroup extends Enumeration implements Comparable<Object>, java.io.Serializable {

  private static int count = 0;

	public static final TransactionTypeGroup CUST_DETAIL_NOT                    = new TransactionTypeGroup(TransactionType.CUST_DETAIL_NOT                   , TransactionGroup.CUST);
	public static final TransactionTypeGroup CUST_DETAIL_REQUEST                = new TransactionTypeGroup(TransactionType.CUST_DETAIL_REQUEST               , TransactionGroup.CUST);
	public static final TransactionTypeGroup METER_DATA_NOT                     = new TransactionTypeGroup(TransactionType.METER_DATA_NOT                    , TransactionGroup.MTRD);
	public static final TransactionTypeGroup METER_DATA_VERIFY_REQ              = new TransactionTypeGroup(TransactionType.METER_DATA_VERIFY_REQ             , TransactionGroup.MTRD);
	public static final TransactionTypeGroup NOTICE_OF_METERING_WORKS           = new TransactionTypeGroup(TransactionType.NOTICE_OF_METERING_WORKS          , TransactionGroup.OWNX);
	public static final TransactionTypeGroup PROVIDE_METER_DATA_REQ             = new TransactionTypeGroup(TransactionType.PROVIDE_METER_DATA_REQ            , TransactionGroup.MTRD);
	public static final TransactionTypeGroup SITE_ACCESS_NOT                    = new TransactionTypeGroup(TransactionType.SITE_ACCESS_NOT                   , TransactionGroup.SITE);
	public static final TransactionTypeGroup SITE_ACCESS_REQ                    = new TransactionTypeGroup(TransactionType.SITE_ACCESS_REQ                   , TransactionGroup.SITE);
	public static final TransactionTypeGroup SITE_ADDRESS_NOT                   = new TransactionTypeGroup(TransactionType.SITE_ADDRESS_NOT                  , TransactionGroup.SITE);
	public static final TransactionTypeGroup SOR_ALLOCATE_NMI                   = new TransactionTypeGroup(TransactionType.SOR_ALLOCATE_NMI                  , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_CANCEL                         = new TransactionTypeGroup(TransactionType.SOR_CANCEL                        , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_DEENERGISATION                 = new TransactionTypeGroup(TransactionType.SOR_DEENERGISATION                , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_DEENERGISATION_LOC_MET_DISCONN = new TransactionTypeGroup(TransactionType.SOR_DEENERGISATION_LOC_MET_DISCONN, TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_DEENERGISATION_REC_DISCR       = new TransactionTypeGroup(TransactionType.SOR_DEENERGISATION_REC_DISCR      , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_DEENERGISATION_REMOTE          = new TransactionTypeGroup(TransactionType.SOR_DEENERGISATION_REMOTE         , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_DEENERGISATION_REMOVE_FUSE     = new TransactionTypeGroup(TransactionType.SOR_DEENERGISATION_REMOVE_FUSE    , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MISCELLANEOUS                  = new TransactionTypeGroup(TransactionType.SOR_MISCELLANEOUS                 , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_CHG_TSWITCH                = new TransactionTypeGroup(TransactionType.SOR_MSW_CHG_TSWITCH               , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_EXCHANGE_METER             = new TransactionTypeGroup(TransactionType.SOR_MSW_EXCHANGE_METER            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_INSTALL_CLOAD              = new TransactionTypeGroup(TransactionType.SOR_MSW_INSTALL_CLOAD             , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_INSTALL_METER              = new TransactionTypeGroup(TransactionType.SOR_MSW_INSTALL_METER             , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_METER_INV_INS              = new TransactionTypeGroup(TransactionType.SOR_MSW_METER_INV_INS             , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_METER_INV_TEST             = new TransactionTypeGroup(TransactionType.SOR_MSW_METER_INV_TEST            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_METER_RECONFIG             = new TransactionTypeGroup(TransactionType.SOR_MSW_METER_RECONFIG            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_MOVE_METER                 = new TransactionTypeGroup(TransactionType.SOR_MSW_MOVE_METER                , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_REMOVE_METER               = new TransactionTypeGroup(TransactionType.SOR_MSW_REMOVE_METER              , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_MSW_RESEAL                     = new TransactionTypeGroup(TransactionType.SOR_MSW_RESEAL                    , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_NEW_CONNECTION                 = new TransactionTypeGroup(TransactionType.SOR_NEW_CONNECTION                , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_NEW_CONNECTION_T               = new TransactionTypeGroup(TransactionType.SOR_NEW_CONNECTION_T              , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_NEW_CONNECTION_TP              = new TransactionTypeGroup(TransactionType.SOR_NEW_CONNECTION_TP             , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_SUPPLY_ALTERATION              = new TransactionTypeGroup(TransactionType.SOR_SUPPLY_ALTERATION             , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION                 = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION                , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_AFT_DISCONN     = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_AFT_DISCONN    , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_MOVEIN          = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_MOVEIN         , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_NEW_READ        = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_NEW_READ       , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_PHY_VISIT       = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_PHY_VISIT      , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_REC_DISCR       = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_REC_DISCR      , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_REENERGISATION_RETRO_MOVEIN    = new TransactionTypeGroup(TransactionType.SOR_REENERGISATION_RETRO_MOVEIN   , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_RESPONSE                       = new TransactionTypeGroup(TransactionType.SOR_RESPONSE                      , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_SPECIAL_READ                   = new TransactionTypeGroup(TransactionType.SOR_SPECIAL_READ                  , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_SPECIAL_READ_CHECK             = new TransactionTypeGroup(TransactionType.SOR_SPECIAL_READ_CHECK            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_SPECIAL_READ_FINAL             = new TransactionTypeGroup(TransactionType.SOR_SPECIAL_READ_FINAL            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_SUPPLY_ABOLISHMENT             = new TransactionTypeGroup(TransactionType.SOR_SUPPLY_ABOLISHMENT            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_TARIFF_CHANGE                  = new TransactionTypeGroup(TransactionType.SOR_TARIFF_CHANGE                 , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_TEMP_ISOLATION                 = new TransactionTypeGroup(TransactionType.SOR_TEMP_ISOLATION                , TransactionGroup.SORD);
	public static final TransactionTypeGroup SOR_TEMP_ISOLATION_GRP             = new TransactionTypeGroup(TransactionType.SOR_TEMP_ISOLATION_GRP            , TransactionGroup.SORD);
	public static final TransactionTypeGroup SO_APPOINTMENT_NOT                 = new TransactionTypeGroup(TransactionType.SO_APPOINTMENT_NOT                , TransactionGroup.SORD);

  // 23-Jan-2009 Eddie Graham Defect 4793. Add new constant ONE_WAY_NOT.
	public static final TransactionTypeGroup ONE_WAY_NOT                        = new TransactionTypeGroup(TransactionType.ONE_WAY_NOT                       , TransactionGroup.OWNP);
	public static final TransactionTypeGroup REMOTE_SERVICE_REQ                 = new TransactionTypeGroup(TransactionType.REMOTE_SERVICE_REQ                , TransactionGroup.MRSR);
	public static final TransactionTypeGroup REMOTE_SERVICE_RES                 = new TransactionTypeGroup(TransactionType.REMOTE_SERVICE_RES                , TransactionGroup.MRSR);
	public static final TransactionTypeGroup PLANNED_INTERRUPT_NOT              = new TransactionTypeGroup(TransactionType.PLANNED_INTERRUPT_NOT             , TransactionGroup.OWNX);
	public static final TransactionTypeGroup METER_FAULT_AND_ISSUE_NOT          = new TransactionTypeGroup(TransactionType.METER_FAULT_AND_ISSUE_NOT         , TransactionGroup.OWNX);
	public static final TransactionTypeGroup NOTIFIED_PARTY     				= new TransactionTypeGroup(TransactionType.NOTIFIED_PARTY, TransactionGroup.NPNX);
    public static final TransactionTypeGroup PEER_TO_PEER     = new TransactionTypeGroup(TransactionType.PEER_TO_PEER, TransactionGroup.PTPE);



	private static final TransactionTypeGroup[] TRANSACTION_TYPE_GROUP_ARRAY = {
		CUST_DETAIL_NOT,
		CUST_DETAIL_REQUEST,
		METER_DATA_NOT,
		METER_DATA_VERIFY_REQ,
		METER_FAULT_AND_ISSUE_NOT,
		NOTICE_OF_METERING_WORKS,
		ONE_WAY_NOT,
		PLANNED_INTERRUPT_NOT,
		PROVIDE_METER_DATA_REQ,
		REMOTE_SERVICE_REQ,
		REMOTE_SERVICE_RES,
		SITE_ACCESS_NOT,
		SITE_ACCESS_REQ,
		SITE_ADDRESS_NOT,
		SOR_ALLOCATE_NMI,
		SOR_CANCEL,
		SOR_DEENERGISATION,
		SOR_DEENERGISATION_LOC_MET_DISCONN,
		SOR_DEENERGISATION_REC_DISCR,
		SOR_DEENERGISATION_REMOTE,
		SOR_DEENERGISATION_REMOVE_FUSE,
		SOR_MISCELLANEOUS,
		SOR_MSW_CHG_TSWITCH,
		SOR_MSW_EXCHANGE_METER,
		SOR_MSW_INSTALL_CLOAD,
		SOR_MSW_INSTALL_METER,
		SOR_MSW_METER_INV_INS,
		SOR_MSW_METER_INV_TEST,
		SOR_MSW_METER_RECONFIG,
		SOR_MSW_MOVE_METER,
		SOR_MSW_REMOVE_METER,
		SOR_MSW_RESEAL,
		SOR_NEW_CONNECTION,
		SOR_NEW_CONNECTION_T,
		SOR_NEW_CONNECTION_TP,
		SOR_SUPPLY_ALTERATION,
		SOR_REENERGISATION,
		SOR_REENERGISATION_AFT_DISCONN,
		SOR_REENERGISATION_MOVEIN,
		SOR_REENERGISATION_NEW_READ,
		SOR_REENERGISATION_PHY_VISIT,
		SOR_REENERGISATION_REC_DISCR,
		SOR_REENERGISATION_RETRO_MOVEIN,
		SOR_RESPONSE,
		SOR_SPECIAL_READ,
		SOR_SPECIAL_READ_CHECK,
		SOR_SPECIAL_READ_FINAL,
		SOR_SUPPLY_ABOLISHMENT,
		SOR_TARIFF_CHANGE,
		SOR_TEMP_ISOLATION,
		SOR_TEMP_ISOLATION_GRP,
		SO_APPOINTMENT_NOT,
    NOTIFIED_PARTY,
    PEER_TO_PEER
		};

  public static final List TRANSACTION_TYPE_GROUPS =
    Collections.unmodifiableList(Arrays.asList(TRANSACTION_TYPE_GROUP_ARRAY));

  private final TransactionType transactionType;
  private final TransactionGroup transactionGroup;

  private TransactionTypeGroup(TransactionType transactionType,
      TransactionGroup transactionGroup) {
    this.transactionType = transactionType;
    this.transactionGroup = transactionGroup;
    this.code = null;
    this.description = null;
    this.number = ++count;
  }

  /**
   * Return the TransactionTypeGroup object given by the transactionType (key)
   *
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static TransactionTypeGroup getTransactionTypeGroup(TransactionType transactionType) {
    for (int i = 0; i < TRANSACTION_TYPE_GROUPS.size(); i++) {
      if (((TransactionTypeGroup)TRANSACTION_TYPE_GROUPS.get(i)).getTransactionType() == transactionType)
          return (TransactionTypeGroup) TRANSACTION_TYPE_GROUPS.get(i);
    }
    return null;
  }

  /**
   * @return Returns the transactionType.
   */
  public TransactionType getTransactionType() {
    return transactionType;
  }

  /**
   * @return Returns the transactionGroup.
   */
  public TransactionGroup getTransactionGroup() {
    return transactionGroup;
  }

	public static String getTransactionTypeGroupCode(String transactionTypeCode) {
		for (int i = 0; i < TRANSACTION_TYPE_GROUPS.size(); i++) {
			if (((TransactionTypeGroup)TRANSACTION_TYPE_GROUPS.get(i)).getTransactionType().getCode() == transactionTypeCode)
				return  ((TransactionTypeGroup) TRANSACTION_TYPE_GROUPS.get(i)).getTransactionGroup().getCode();
		}
		return null;
	}
}

