/*
 * Voltage.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By       Description
 * ------------   ----------       -----------
 * 11-Jul-2017    SP                Created as part of the SMP new screens
 */

package com.capgemini.nemmco.b2bb.enums;

import java.io.Serializable;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class Voltage extends Enumeration implements Comparable<Object>, Serializable {
   // Public constants
   private static int count = 0;

    /**
        * The following define the enumerations.
        */
    public static final Voltage V230           = new Voltage("230V", "230V");
    public static final Voltage V400     = new Voltage("400V", "400V");
    public static final Voltage KV11 = new Voltage("11KV", "11KV");
    public static final Voltage KV22 = new Voltage("22KV", "22KV");
   public static final Voltage KV33           = new Voltage("33KV", "33KV");
   public static final Voltage KV66     = new Voltage("66KV", "66KV");
   public static final Voltage KV132 = new Voltage("132KV", "132KV");
   public static final Voltage OTHER = new Voltage("Other HV", "Other HV");

    private static final Voltage[] VOLTAGE_ARRAY =
      { V230,
        V400,
         KV11,
       KV22,
       KV33,
      KV66,
      KV132,
      OTHER
      };

    public static final List<? extends Object> VOLTAGES =
      Collections.unmodifiableList(Arrays.asList(VOLTAGE_ARRAY));

    private Voltage(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }
}
