/**
 * @(#)B2BParticipantRole 0.1 Jul 27, 2005
 *
 * Copyright 2005 Capgemini Pty. Ltd. All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * 
 * Modification History
 * ====================
 * Date Changed  Changed By         Comments
 * ------------  ----------         ----------------
 * Jul 27, 2005  Bryan Kim          Initial Creation
 * May  8  2008  Oleg Pevzner       Def 2963 Second NSP Role
 * 14-Aug-2012   Bob Jones          7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.lookup;

import java.util.List;

import com.capgemini.nemmco.b2bb.exceptions.UnableToLookupResourceException;

/**
 * Defines the Database Lookup field for B2B-only roles
 *
 * @author  Bryan Kim
 * @version 0.1, Jul 27, 2005
 */
public class B2BParticipantRole extends ParticipantRole implements Comparable<Object>, java.io.Serializable {

  private static int count = 0;

  /**
   * The static classes are used to define and retrieve B2B-only 
   * participant role list
   */
  public static List<Object> getList() throws UnableToLookupResourceException {
    return null;
  }
  
  protected B2BParticipantRole(String code, String description) {
    super(code, description);
  }

  public static boolean contains(String role) throws UnableToLookupResourceException {
     return false;
  }
}

