/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/lookup/EventMessage.java-arc   1.6   11 Apr 2005 11:10:28   RayanS  $
 * $Revision:   1.6  $
 * $Date:   11 Apr 2005 11:10:28  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.lookup;

import java.util.Arrays;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Vector;

import com.capgemini.nemmco.b2bb.exceptions.UnableToLookupResourceException;

/**
 * Defines the Properties file Lookup fields
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.6  $ $Date:   11 Apr 2005 11:10:28  $
 */

public class EventMessage extends Lookup
                          implements Comparable<Object>, java.io.Serializable {
  

  private static int count = 0;
  
  final int number;
  
  // private constants
  private static String FileName = "com.capgemini.nemmco.b2bb.lookup.EventMessage";
  private static List<Object> list = null;
  
  // Public static methods
  /**
	  * The static classes are used to define and retrieve enumerations from the resource bundle.
	  */
  public static List<? extends Object> getList() throws UnableToLookupResourceException {
    if (list != null) return list;
    Vector<Object> values = new Vector<Object>();
    ResourceBundle resources = null;
    try {
      resources = ResourceBundle.getBundle(FileName);
    } catch (MissingResourceException e){
      throw new UnableToLookupResourceException(e.getMessage());
    }
    Enumeration<String> en = resources.getKeys();
    while (en.hasMoreElements()) {
      String tmpKey = en.nextElement();
      values.add(new EventMessage(tmpKey,(String)resources.getObject(tmpKey)));
    }

    // create a list to return
    list =  Collections.unmodifiableList(Arrays.asList(values.toArray()));
    return list;
  }

  
  /**
   * Given a eventcode code it will return the participant object representing the code
   * 
   * @param eventcode the eventcode to look up
   * @return the eventcode representing the String. Null if not found
   * @throws UnableToLookupResourceException if the database is not accessible
   */
  public static EventMessage getEventMessage(String eventcode) throws UnableToLookupResourceException {
    List<? extends Object> list = EventMessage.getList();
    for (int i = 0 ; i < list.size(); i++){
      if ((((Lookup) list.get(i)).getCode()).equals(eventcode)) return (EventMessage) list.get(i);
    }
    return null;  
  }


  private EventMessage(String code, 
                       String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }


  public String getDescription() {
    return description;
  }

  public String toString() {
    return code + "-" + description;
  }

}

