/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/ValidationModule/src/com/capgemini/nemmco/b2bb/lookup/Participant.java-arc   1.1   08 Apr 2005 14:26:56   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:26:56  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 28-Aug-2012    Oleg Pevzner      7984 Java upgrade from 6 to 7.
 * 22-Sep-2017    Harpreet Kaur     Package 24 : Added new method getAllParticipants() to display participants depending upon sendToAnyParticipant value
 */
package com.capgemini.nemmco.b2bb.lookup;

import java.sql.Date;
import java.util.List;

import com.capgemini.nemmco.b2bb.exceptions.UnableToLookupResourceException;

/**
 * Defines the Database Lookup field
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:26:56  $
 */

public class Participant extends Lookup implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  private final String shortname;
  private final String participantname;
  private final Date startdate;
  private final Date enddate;
  private final String directory;

  // Public static methods
  /**
   * The static classes are used to define and retrieve enumerations from the database.
   * 
   * @return A List of Participant Objects
   * @throws UnableToLookupResourceException if the database is not accessible
   */
  public static List<Participant> getList() throws UnableToLookupResourceException {
    List<Participant> l=null;  
    return l;
  }

  /**
   * Given a participant code it will return the participant object representing the code
   * 
   * @param participant the participant to look up
   * @return the Participant representing the String. Null if not found
   * @throws UnableToLookupResourceException if the database is not accessible
   */
  public static Participant getParticipant(String participant) throws UnableToLookupResourceException {
    return null;
  }

  /**
   * Given a participant code it will return true or false depending if the participant exists
   * 
   * @param participant the participant to look up
   * @return True if participant exists. False otherwise
   * @throws UnableToLookupResourceException if the database is not accessible
   */
  public static boolean contains(String participant) throws UnableToLookupResourceException {
    return false;
  }

  private Participant(String code, String shortname, String participantname, Date startdate, Date enddate, String directory) {
    this.code = code;
    this.description = shortname;
    this.shortname = shortname;
    this.participantname = participantname;
    this.startdate = startdate;
    this.enddate = enddate;
    this.directory = directory;
    this.number = ++count;
  }

  public String getShortName() {
    return shortname;
  }

  public String getName() {
    return participantname;
  }

  public Date getStartDate() {
    return startdate;
  }

  public Date getEndDate() {
    return enddate;
  }

  public String getDirectory() {
    return directory;
  }

  public String toString() {
    return code + "-" + shortname;
  }

  public static List<Participant> getList(String transactionDesc, String np) {
    List<Participant> l=null;
    return l;
  }
 /**
    * Getting the participant list based on the sendToAnyParticipant
    *
    * @return A List of Participant Objects
    * @throws UnableToLookupResourceException if the database is not accessible
    */
 public static List<Participant> getAllParticipants() throws UnableToLookupResourceException {
    List<Participant> l=null;  
    return l;
  }
}

