/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/lookup/XPathComparator.java-arc   1.0   Mar 11 2005 09:30:40   adij  $
 * $Revision:   1.0  $
 * $Date:   Mar 11 2005 09:30:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.lookup;

import java.util.Comparator;

import com.capgemini.nemmco.b2bb.lookup.XPath;

/**
 * The comparator class to sort File objects
 * 
 * @author $Author:   adij  $
 * @version $Revision:   1.0  $ $Date:   Mar 11 2005 09:30:40  $
 */
public class XPathComparator implements Comparator<Object> {

  public XPathComparator() {
  }
  
  public String getOrder(String field) {
    int openIndex = field.indexOf("[");
    int closeIndex = field.lastIndexOf("]");
    
    if (openIndex > -1 && closeIndex > -1) {
      return field.substring(openIndex + 1, closeIndex);
    } else {
      return null;
    }
  }

  public int compare(Object o1, Object o2) {
    String category1;
    String category2;
    
    String number1 = null;
    String number2 = null;
    
    int num1 = 0;
    int num2 = 0;

    if (o1 == o2)
      return 0;

    XPath x1 = (XPath) o1;
    XPath x2 = (XPath) o2;

    category1 = x1.getCode();
    category2 = x2.getCode();
    
    if (category1 != null) {
      number1 = getOrder(category1);
      if (number1 != null) {
        num1 = Integer.parseInt(number1);
      }
    }
    
    if (category1 != null) {
      number2 = getOrder(category2);
      if (number2 != null) {
        num2 = Integer.parseInt(number2);
      }
    }
    
    return num1 - num2;
  }
}