/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/EventObjectBasicValidator.java-arc   1.1   11 Apr 2005 11:11:10   RayanS  $
 * $Revision:   1.1  $
 * $Date:   11 Apr 2005 11:11:10  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 */

package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.XMLObject;
import com.capgemini.nemmco.b2bb.utils.EventObject;

/**
 * The class <code>EventObjectBasicValidator</code> is the Validator 
 * object of the EventObject.
 * 
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   11 Apr 2005 11:11:10  $
 */
public class EventObjectBasicValidator extends XMLObjectValidator {
  private EventObject event;

  /**
   * Constructor. Sets a transaction with the objects initialisation.
   * @param event event to use in the validator.
   */
  public EventObjectBasicValidator(XMLObject event) {
    super(event);
    this.event = (EventObject) event;
  }

  /**
   * Validate the event
   * 
   * @return boolean result of validation
   * validation is called.
   */
  public boolean validate() {
    boolean result = true;
    
    result &= validateClass()
        & validateSeverity()
        & validateEventCode()
        & validateEventDescription()
        & validateKeyInfo()
        & validateContext()
        & validateExplanation()
        & validateSupportedVersions();

    return result;
  }
  
  protected boolean validateClass() {
    String field = EventObject.EVENT_CLASS;
    return !validator.exists(event.getEventClass())
        || validator.validateEventClass(events, category, field, event.getEventClass());
  }

  protected boolean validateSeverity() {
    String field = EventObject.SEVERITY;
    return !validator.exists(event.getSeverity())
        || validator.validateSeverity(events, category, field, event.getSeverity());
  }
  
  protected boolean validateEventCode() {
    String field = EventObject.EVENT_CODE;
    return validator.validateMandatory(events, category, field, event.getEventCode())
        && validator.validateNumeric(events, category, field, event.getEventCode());
  }
  
  protected boolean validateEventDescription() {
    return true;
  }
  
  protected boolean validateKeyInfo() {
    String field = EventObject.KEY_INFO;
    return validator.validateLengthRange(events, category, field, event.getKeyInfo(), 0, 80);
  }
  
  protected boolean validateContext() {
    String field = EventObject.CONTEXT;
    return validator.validateLengthRange(events, category, field, event.getContext(), 0, 80);
  }
  
  protected boolean validateExplanation() {
    return true;
  }

  protected boolean validateSupportedVersions() {
//    String field = EventObject.SUPPORT_VERSIONS;
//    return !validator.exists(event.getEventClass())
//        || validator.validatePattern(events, category, field, event.getSupportedVersions(), "r[0-9]*|r[0-9]*_[a-z][0-9]*");
  
    return true;
  }
}

